#include "Helper.h"

//#define	DEST_IP		"127.0.0.1" //local host
//#define	MYPORT		3131	// the port users will be connecting to

//CLIENT
#define	BACKLOG		10		// how many pending connections queue will hold
#define SERIP		"127.0.0.1"
#define SERPORT		5000
STRING MYIP;

//UPLOADER
#define	FILESIZE	10000	// The maximum allowed file size
STRING UPPORT;

STRING home = "./";
Helper helper( "client.log");

int downloadHandler(STRING filename, STRING theIP, STRING thePort)
{
	helper.logger( "In download: {");
	
	char temp[FILESIZE];
	int sockfd;
	struct sockaddr_in dest_addr; // will hold the destination addr

	helper.logger( "Initializing socket");
	
	sockfd = socket(AF_INET, SOCK_STREAM, 0);

	if (sockfd == -1)
		return -1;

	dest_addr.sin_family = AF_INET; // host byte order
	dest_addr.sin_port = htons(helper.str2int(thePort)); // short, network byte order
	dest_addr.sin_addr.s_addr = inet_addr(theIP.c_str());
	memset(&(dest_addr.sin_zero), '\0', 8); // zero the rest of the struct

	helper.logger( "Connecting to server");
	helper.logger("Port:" + thePort);
	helper.logger("IP:" + theIP);

	if (connect(sockfd, (struct sockaddr *)&dest_addr, sizeof(struct sockaddr)) == -1)
	{
		shutdown(sockfd, SHUT_RDWR);
		close(sockfd);
		helper.logger("cannot connect for download!!");
		return -1;
	}

	helper.logger( "Sending data");

	int thesize = filename.size();

	send(sockfd, &thesize, sizeof(int), 0);
	send(sockfd, filename.c_str(), thesize, 0);
	
	recv(sockfd, temp, 1, 0);
	
	if(temp[0] == 1)
	{
		recv(sockfd, &thesize, sizeof(int), 0);
		recv(sockfd, temp, thesize, 0);
		
		OFSTREAM out;
		out.open(filename.c_str(), IOS::out|IOS::binary);
		
		out.write(temp, thesize);
		out.close();

		helper.logger( "File has downloaded");
	}
	else
	{
		helper.logger( "File not found");
		shutdown(sockfd, SHUT_RDWR);
		close(sockfd);
		return -1;
	}	

	helper.logger( "}");

	shutdown(sockfd, SHUT_RDWR);
	close(sockfd);

	return 1;
}

int sendAll(int fd , char * buf , int *len )
{
	helper.logger("In SendAll");
	
	int total = 0;
	int bytesLeft = *len ;
	int n;
	while (total < *len)
	{
		n = send (fd , buf+total , bytesLeft , 0 );
		if ( n== -1 ) break ;
		total += n;
		bytesLeft -= n;		
	}
	
	*len = total ;
	return (n==-1?-1:0);
}

void publishHandler(int fd, STRING name, STRING key)
{
	helper.logger("In PublishHandler");
	
	char msg[1000] = "publish:";

	strcat(msg , key.c_str());
	strcat(msg,":");
	strcat (msg,name.c_str());
	strcat(msg,":");
	strcat(msg, MYIP.c_str());
	strcat(msg,":");
	strcat(msg, UPPORT.c_str());
	strcat(msg,":");
	int len = strlen (msg);
	sendAll ( fd , msg , &len  );		
}

void searchHandler( int fd, STRING key)
{
	helper.logger("In Upload");
	
	char  msg [1000] = "search:" ;

	strcat(msg ,key.c_str());
	strcat (msg,"\0");
	int len = strlen(msg);
	sendAll (fd , msg , &len );
	
	
	char temp[256];
	helper.logger( "In service_requests:");

	int thesize;
	int iteration;
	STRING gotit;
	
	if(recv(fd, &iteration, sizeof(int), 0) != -1)
	{
		helper.logger( "Receiving: {");
		helper.logger( "\tNumber of elements: " + helper.int2str( iteration));
		
		for(int i = 0; i < iteration; i++)
		{
			COUT << i + 1 << ". " << ENDL;
			
			recv(fd, &thesize, sizeof(int), 0);
			helper.logger( "\tSize of the key: " + helper.int2str( thesize));
			recv(fd, temp, thesize, 0);
			gotit = temp;
			gotit.resize(thesize);
			helper.logger( "\tKey: " + gotit);
			COUT << "\tKey: " << gotit << ENDL;
			
			recv(fd, &thesize, sizeof(int), 0);
			helper.logger( "\tSize of the FileName: " + helper.int2str( thesize));
			recv(fd, temp, thesize, 0);
			gotit = temp;
			gotit.resize(thesize);
			helper.logger( "\tFileName: " + gotit);
			COUT << "\tFileName: " << gotit << ENDL;
			
			recv(fd, &thesize, sizeof(int), 0);
			helper.logger( "\tSize of the IP: " + helper.int2str( thesize));
			recv(fd, temp, thesize, 0);
			gotit = temp;
			gotit.resize(thesize);
			helper.logger( "\tIP: " + gotit);
			COUT << "\tIP: " << gotit << ENDL;
			
			recv(fd, &thesize, sizeof(int), 0);
			helper.logger( "\tSize of the Port: " + helper.int2str( thesize));
			recv(fd, temp, thesize, 0);
			gotit = temp;
			gotit.resize(thesize);
			helper.logger( "\tPort: " + gotit);
			COUT << "\tPort: " << gotit << ENDL;
		}
	}	
}


void *upload(void *parameter)
{
	helper.logger( "In upload: {");

	char temp[FILESIZE];
	int new_fd = int(parameter);
	int thesize;
	STRING filename;
	
	if(recv(new_fd, &thesize, sizeof(int), 0) != -1)
	{
		helper.logger( "Receiving:");
		helper.logger( "\tSize of the name: ");
		helper.logger(helper.int2str(thesize));
		
		recv(new_fd, temp, thesize, 0);
		temp[thesize] = 0;
		filename = home + temp;
		
		helper.logger( "\tFile Name: " + filename);
		
		if(helper.ifFileExist(filename))
		{			
			IFSTREAM inp;
			inp.open(filename.c_str(), IOS::in|IOS::binary);
		
			int b = inp.tellg();
			inp.seekg(0, IOS::end);
			int size = inp.tellg();
			size -= b;

			helper.logger( "File Size:" + helper.int2str(size));

			if(size <= FILESIZE)
			{
				temp[0] = 1;
				send(new_fd, temp, 1, 0);
				send(new_fd, &size, sizeof(size), 0);
				inp.seekg(0, IOS::beg);				
				inp.read(temp, size);			
				send(new_fd, temp, size, 0);
				
				helper.logger( "File has sent");
			}
			else
			{
				temp[0] = 0;
				send(new_fd, temp, 1, 0);
				helper.logger( "File has not been sent because it's too big");				
			}
			
			inp.close();			
		}
		else
		{
			helper.logger( "File doe's not exist");
			temp[0] = 0;
			send(new_fd, temp, 1, 0);
		}
	}
	else
		helper.logger( "Socket problem for sending");

	helper.logger( "}");
			
	shutdown(new_fd, SHUT_RDWR);
	close(new_fd);

	return NULL;
}

void *listener(void *parameter)
{
	helper.logger( "In listener:");

	int sockfd = *(int *)parameter;
	int new_fd; // new connection on new_fd
	struct sockaddr_in my_addr; // my address information
	struct sockaddr_in their_addr; // connector?s address information
	socklen_t sin_size;
	pthread_t thread_id;
	
	my_addr.sin_family = AF_INET; // host byte order
	my_addr.sin_port = htons( helper.str2int(UPPORT)); // short, network byte order
	my_addr.sin_addr.s_addr = INADDR_ANY; // auto-fill with my IP
	memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct

	if(bind(sockfd, (struct sockaddr *)&my_addr, sizeof(struct sockaddr)) == -1)
	{
		helper.logger( "Cannot bind address to socket");
		
		return NULL;
	}

	helper.logger( "Port: " + UPPORT);
	
	if(listen(sockfd, BACKLOG) == -1)
	{
		helper.logger( "Cannot listen to socket");

		return NULL;
	}

	while(1)
	{		
		helper.logger( "Incoming new connection before accept");

		sin_size = sizeof(struct sockaddr_in);
		new_fd = accept(sockfd, (struct sockaddr *)&their_addr, &sin_size);

		helper.logger( "Incoming new connection");

		if(new_fd == -1)
		{
			helper.logger( "Error in accepting new socket");

			break;
		}
		
		helper.logger( "Going to Upload");
		
		pthread_create(&thread_id, NULL, &upload, (void *)new_fd);
	}

	return NULL;
}
void exitHandler(int fd )
{

	send (fd , "end:", 4, 0);
}


int main(int margs, char * margv[])
{
	helper.logger("In Client");
	
	if(margs == 3)
	{
		MYIP = margv[1];
		UPPORT = margv[2];
	}
	else
	{
		MYIP = "127.0.0.1";
		UPPORT = "3131";
	}
		
	int args;
	char command[256];
	STRING allcommands[] = { "publish", "search", "download", "exit"};
	char * argv[256];
	command[0] = 0;
	
	int sockup; // listen on sock_fd, new connection on new_fd
	sockup = socket(AF_INET, SOCK_STREAM, 0);
	
	if (sockup == -1)
	{
		helper.logger( "Cannot stablish port");

		return -1;
	}

	int theserver;
	struct sockaddr_in dest_addr; // will hold the destination addr

	helper.logger( "Initializing socket");
	
	theserver = socket(AF_INET, SOCK_STREAM, 0);

	if (theserver == -1)
		return -1;

	dest_addr.sin_family = AF_INET; // host byte order
	dest_addr.sin_port = htons(SERPORT); // short, network byte order
	dest_addr.sin_addr.s_addr = inet_addr(SERIP);
	memset(&(dest_addr.sin_zero), '\0', 8); // zero the rest of the struct

	helper.logger( "Connecting to server");

	if (connect(theserver, (struct sockaddr *)&dest_addr, sizeof(struct sockaddr)) == -1)
	{
		shutdown(theserver, SHUT_RDWR);
		close(theserver);
		return -1;
	}

	char validity = 0;

	recv(theserver, &validity, 1, 0);

	if( !validity)
	{
		helper.logger( "The server is too busy!!");
		COUT << "The server is too busy!!" << ENDL;
		shutdown(sockup, SHUT_RDWR);
		close(sockup);
		shutdown(theserver, SHUT_RDWR);
		close(theserver);
	
		return -1;
	}
	
	pthread_t thread_id;
	pthread_create(&thread_id, NULL, &listener, &sockup);

	for(;;)
	{
		COUT << "/> ";
		CIN.getline( command, 255);
		
		while(command[0] == 0)
			CIN.getline( command, 255);
		
		args = 0;

		for( int ind = 0; command[ind] != 0;)
		{
			argv[args] = command + ind;			
				
			while( command[ind] != ' ' && command[ind] != 0)
				ind++;

			if( command[ind] != 0)
			{
				command[ind] = 0;
				ind++;
			}

			args++;	
			argv[args] = NULL;
		}
	
		if( argv[0] == NULL)
			continue;

		if( allcommands[0] == argv[0])
		{
			if( args == 3)
			{
				publishHandler( theserver, argv[1], argv[2]);
			}
			else
				COUT << "The publish instruction gets 2 parameters !!" << ENDL;
		}
		else if( allcommands[1] == argv[0])
		{
			if( args == 2)
			{
				searchHandler( theserver, argv[1]);
			}
			else
				COUT << "The search instruction gets 1 parameters !!" << ENDL;
		}
		else if( allcommands[2] == argv[0])
		{	
			if( args == 4)
			{
				downloadHandler(argv[1], argv[2], argv[3]);
			}
			else				
				COUT << "The download instruction gets 3 parameters !!" << ENDL;		
		}
		else if( allcommands[3] == argv[0])
		{
			if( args == 1)
			{
				exitHandler(theserver);
				break;
			}
			else				
				COUT << "The exit instruction gets 0 parameters !!" << ENDL;
		}
		else
		{
			COUT << "Unknown command !!" << ENDL;
			continue;
		}
	}

	shutdown(sockup, SHUT_RDWR);
	close(sockup);
	shutdown(theserver, SHUT_RDWR);
	close(theserver);
	
	return 0;
}



